DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Scheduler - Resources

Users can categorize appointments by resources. The following example illustrates what resources are: in an educational center lectures are held in several rooms. In JavaScript Scheduler terms, room is a resource kind, individual rooms are resource instances, and lectures are appointments that use these resource instances.

Backend API
$(() => { const scheduler = $('#scheduler').dxScheduler({ timeZone: 'America/Los_Angeles', dataSource: data, views: ['workWeek'], currentView: 'workWeek', currentDate: new Date(2021, 3, 27), startDayHour: 9, endDayHour: 19, resources: [ { fieldExpr: 'roomId', dataSource: rooms, label: 'Room', icon: 'conferenceroomoutline', }, { fieldExpr: 'priorityId', dataSource: priorities, label: 'Priority', icon: 'tags', }, { fieldExpr: 'assigneeId', allowMultiple: true, dataSource: assignees, label: 'Assignee', icon: 'user', }], editing: { form: { items: [ { name: 'mainGroup', items: [ 'subjectGroup', 'dateGroup', 'repeatGroup', { name: 'resourcesGroup', items: [ { name: 'roomIdGroup', colCount: 3, colCountByScreen: { xs: 3, }, items: [ 'roomIdIcon', 'roomIdEditor', 'priorityIdEditor', ], }, 'assigneeIdGroup', ], }, 'descriptionGroup', ], }, 'recurrenceGroup', ], }, }, height: 600, }).dxScheduler('instance'); $('#resources-selector').dxRadioGroup({ items: resourcesList, value: resourcesList[0], layout: 'horizontal', onValueChanged(e) { const resources = scheduler.option('resources'); scheduler.option('resources', resources.map((resource) => ({ ...resource, useColorAsDefault: resource.label === e.value, }))); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.7"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="scheduler"></div> <div class="options"> <div class="caption">Use colors of:</div> <div class="option"> <div id="resources-selector"></div> </div> </div> </div> </body> </html>
.options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); margin-top: 20px; } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; display: inline-block; }
const resourcesList = ['Assignee', 'Room', 'Priority']; const data = [ { text: 'Website Re-Design Plan', assigneeId: [4], roomId: 1, priorityId: 2, startDate: new Date('2021-04-26T16:30:00.000Z'), endDate: new Date('2021-04-26T18:30:00.000Z'), }, { text: 'Book Flights to San Fran for Sales Trip', assigneeId: [2], roomId: 2, priorityId: 1, startDate: new Date('2021-04-26T19:00:00.000Z'), endDate: new Date('2021-04-26T20:00:00.000Z'), allDay: true, }, { text: 'Install New Router in Dev Room', assigneeId: [1], roomId: 1, priorityId: 2, startDate: new Date('2021-04-26T21:30:00.000Z'), endDate: new Date('2021-04-26T22:30:00.000Z'), }, { text: 'Approve Personal Computer Upgrade Plan', assigneeId: [3], roomId: 2, priorityId: 2, startDate: new Date('2021-04-27T17:00:00.000Z'), endDate: new Date('2021-04-27T18:00:00.000Z'), }, { text: 'Final Budget Review', assigneeId: [1], roomId: 1, priorityId: 1, startDate: new Date('2021-04-27T19:00:00.000Z'), endDate: new Date('2021-04-27T20:35:00.000Z'), }, { text: 'New Brochures', assigneeId: [4], roomId: 3, priorityId: 2, startDate: new Date('2021-04-27T21:30:00.000Z'), endDate: new Date('2021-04-27T22:45:00.000Z'), }, { text: 'Install New Database', assigneeId: [2], roomId: 3, priorityId: 1, startDate: new Date('2021-04-28T16:45:00.000Z'), endDate: new Date('2021-04-28T18:15:00.000Z'), }, { text: 'Approve New Online Marketing Strategy', assigneeId: [4], roomId: 2, priorityId: 1, startDate: new Date('2021-04-28T19:00:00.000Z'), endDate: new Date('2021-04-28T21:00:00.000Z'), }, { text: 'Upgrade Personal Computers', assigneeId: [2], roomId: 2, priorityId: 2, startDate: new Date('2021-04-28T22:15:00.000Z'), endDate: new Date('2021-04-28T23:30:00.000Z'), }, { text: 'Customer Workshop', assigneeId: [3], roomId: 3, priorityId: 1, startDate: new Date('2021-04-29T18:00:00.000Z'), endDate: new Date('2021-04-29T19:00:00.000Z'), allDay: true, }, { text: 'Prepare 2021 Marketing Plan', assigneeId: [1], roomId: 1, priorityId: 2, startDate: new Date('2021-04-29T18:00:00.000Z'), endDate: new Date('2021-04-29T20:30:00.000Z'), }, { text: 'Brochure Design Review', assigneeId: [4], roomId: 1, priorityId: 1, startDate: new Date('2021-04-29T21:00:00.000Z'), endDate: new Date('2021-04-29T22:30:00.000Z'), }, { text: 'Create Icons for Website', assigneeId: [3], roomId: 3, priorityId: 1, startDate: new Date('2021-04-30T17:00:00.000Z'), endDate: new Date('2021-04-30T18:30:00.000Z'), }, { text: 'Upgrade Server Hardware', assigneeId: [4], roomId: 2, priorityId: 2, startDate: new Date('2021-04-30T21:30:00.000Z'), endDate: new Date('2021-04-30T23:00:00.000Z'), }, { text: 'Submit New Website Design', assigneeId: [1], roomId: 1, priorityId: 2, startDate: new Date('2021-04-30T23:30:00.000Z'), endDate: new Date('2021-05-01T01:00:00.000Z'), }, { text: 'Launch New Website', assigneeId: [2], roomId: 3, priorityId: 1, startDate: new Date('2021-04-30T19:20:00.000Z'), endDate: new Date('2021-04-30T21:00:00.000Z'), }, ]; const assignees = [ { text: 'Samantha Bright', id: 1, color: '#727bd2', }, { text: 'John Heart', id: 2, color: '#32c9ed', }, { text: 'Todd Hoffman', id: 3, color: '#2a7ee4', }, { text: 'Sandra Johnson', id: 4, color: '#7b49d3', }, ]; const rooms = [ { text: 'Room 1', id: 1, color: '#00af2c', }, { text: 'Room 2', id: 2, color: '#56ca85', }, { text: 'Room 3', id: 3, color: '#8ecd3c', }, ]; const priorities = [ { text: 'High', id: 1, color: '#cc5c53', }, { text: 'Low', id: 2, color: '#ff9747', }, ];

Define Resource Kinds

Use the resources array to define resource kinds. Each object in this array should contain at least the following fields:

  • dataSource
    Resource instances of this resource kind. Each instance should contain the id, text, and color fields. If your field names differ, specify them in the valueExpr, displayExpr, and colorExpr properties, respectively.

  • fieldExpr
    A data field used to assign instances of this resource kind to appointments. Add this field to appointment objects and set the field values to id values of resource instances.

In this demo, the resources array contains three resource kinds: rooms, priorities, and assignees. Their fieldExpr values are roomId, priorityId, and assigneeId, respectively. Each appointment contains the same fields. Field values assign the appointments to different instances of these resource kinds.

Color Appointments Based on a Resource Kind

To use the color scheme of a specific resource kind, enable the kind's useColorAsDefault property. Otherwise, appointments use the color scheme of the last resource kind declared in the resources array.

This demo enables you to change the useColorAsDefault property at runtime. Click the radio buttons under the JavaScript Scheduler to switch between different color schemes.

Assign Multiple Instances of a Resource Kind

Each resource kind object can contain the allowMultiple property. When this property is set to true, users can assign multiple instances of this kind to a single appointment. In this demo, the Assignee resource kind allows multiple instances.

You can also group appointments by resources as shown in the following demo: Group Orientation.

<dx-scheduler
timeZone="America/Los_Angeles"
[dataSource]="appointmentsData"
[views]="['workWeek']"
currentView="workWeek"
[currentDate]="currentDate"
[startDayHour]="9"
[endDayHour]="19"
[height]="600"
>
<dxi-scheduler-resource
fieldExpr="roomId"
label="Room"
[dataSource]="rooms"
[useColorAsDefault]="currentResource === 'Room'"
icon="conferenceroomoutline"
>
</dxi-scheduler-resource>
<dxi-scheduler-resource
fieldExpr="priorityId"
label="Priority"
[dataSource]="priorities"
[useColorAsDefault]="currentResource === 'Priority'"
icon="tags"
>
</dxi-scheduler-resource>
<dxi-scheduler-resource
fieldExpr="assigneeId"
label="Assignee"
[allowMultiple]="true"
[dataSource]="assignees"
[useColorAsDefault]="currentResource === 'Assignee'"
icon="user"
>
</dxi-scheduler-resource>
<dxo-scheduler-editing>
<dxo-scheduler-form>
<dxi-scheduler-item name="mainGroup">
<dxi-scheduler-item name="subjectGroup"></dxi-scheduler-item>
<dxi-scheduler-item name="dateGroup"></dxi-scheduler-item>
<dxi-scheduler-item name="repeatGroup"></dxi-scheduler-item>
<dxi-scheduler-item name="resourcesGroup">
<dxi-scheduler-item
name="roomIdGroup"
[colCount]="3"
[colCountByScreen]="{ xs: 3 }"
>
<dxi-scheduler-item name="roomIdIcon"></dxi-scheduler-item>
<dxi-scheduler-item name="roomIdEditor"></dxi-scheduler-item>
<dxi-scheduler-item name="priorityIdEditor"></dxi-scheduler-item>
</dxi-scheduler-item>
<dxi-scheduler-item name="assigneeIdGroup"></dxi-scheduler-item>
</dxi-scheduler-item>
<dxi-scheduler-item name="descriptionGroup"></dxi-scheduler-item>
</dxi-scheduler-item>
<dxi-scheduler-item name="recurrenceGroup"></dxi-scheduler-item>
</dxo-scheduler-form>
</dxo-scheduler-editing>
</dx-scheduler>
<div class="options">
<div class="caption">Use colors of:</div>
<div class="option">
<dx-radio-group
[items]="resourcesList"
[(value)]="currentResource"
layout="horizontal"
>
</dx-radio-group>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxSchedulerModule, DxRadioGroupModule } from 'devextreme-angular';
import {
Appointment, Service, Assignee, Room, Priority,
} from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
DxSchedulerModule,
DxRadioGroupModule,
],
})
export class AppComponent {
appointmentsData: Appointment[];
assignees: Assignee[];
rooms: Room[];
priorities: Priority[];
resourcesList: string[] = ['Assignee', 'Room', 'Priority'];
currentDate: Date = new Date(2021, 3, 27);
currentResource: string = this.resourcesList[0];
constructor(service: Service) {
this.appointmentsData = service.getAppointments();
this.assignees = service.getAssignees();
this.rooms = service.getRooms();
this.priorities = service.getPriorities();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: inline-block;
}
import { Injectable } from '@angular/core';
export class Appointment {
text: string;
startDate: Date;
endDate: Date;
allDay?: boolean;
assigneeId: number[];
roomId: number;
priorityId: number;
}
export class Assignee {
text: string;
id: number;
color: string;
}
export class Room {
text: string;
id: number;
color: string;
}
export class Priority {
text: string;
id: number;
color: string;
}
const appointments: Appointment[] = [
{
text: 'Website Re-Design Plan',
assigneeId: [4],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-26T16:30:00.000Z'),
endDate: new Date('2021-04-26T18:30:00.000Z'),
}, {
text: 'Book Flights to San Fran for Sales Trip',
assigneeId: [2],
roomId: 2,
priorityId: 1,
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
allDay: true,
}, {
text: 'Install New Router in Dev Room',
assigneeId: [1],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-26T21:30:00.000Z'),
endDate: new Date('2021-04-26T22:30:00.000Z'),
}, {
text: 'Approve Personal Computer Upgrade Plan',
assigneeId: [3],
roomId: 2,
priorityId: 2,
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
assigneeId: [1],
roomId: 1,
priorityId: 1,
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
}, {
text: 'New Brochures',
assigneeId: [4],
roomId: 3,
priorityId: 2,
startDate: new Date('2021-04-27T21:30:00.000Z'),
endDate: new Date('2021-04-27T22:45:00.000Z'),
}, {
text: 'Install New Database',
assigneeId: [2],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-28T16:45:00.000Z'),
endDate: new Date('2021-04-28T18:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
assigneeId: [4],
roomId: 2,
priorityId: 1,
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
assigneeId: [2],
roomId: 2,
priorityId: 2,
startDate: new Date('2021-04-28T22:15:00.000Z'),
endDate: new Date('2021-04-28T23:30:00.000Z'),
}, {
text: 'Customer Workshop',
assigneeId: [3],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T19:00:00.000Z'),
allDay: true,
}, {
text: 'Prepare 2021 Marketing Plan',
assigneeId: [1],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
}, {
text: 'Brochure Design Review',
assigneeId: [4],
roomId: 1,
priorityId: 1,
startDate: new Date('2021-04-29T21:00:00.000Z'),
endDate: new Date('2021-04-29T22:30:00.000Z'),
}, {
text: 'Create Icons for Website',
assigneeId: [3],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-30T17:00:00.000Z'),
endDate: new Date('2021-04-30T18:30:00.000Z'),
}, {
text: 'Upgrade Server Hardware',
assigneeId: [4],
roomId: 2,
priorityId: 2,
startDate: new Date('2021-04-30T21:30:00.000Z'),
endDate: new Date('2021-04-30T23:00:00.000Z'),
}, {
text: 'Submit New Website Design',
assigneeId: [1],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-30T23:30:00.000Z'),
endDate: new Date('2021-05-01T01:00:00.000Z'),
}, {
text: 'Launch New Website',
assigneeId: [2],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-30T19:20:00.000Z'),
endDate: new Date('2021-04-30T21:00:00.000Z'),
},
];
const assignees: Assignee[] = [
{
text: 'Samantha Bright',
id: 1,
color: '#727bd2',
}, {
text: 'John Heart',
id: 2,
color: '#32c9ed',
}, {
text: 'Todd Hoffman',
id: 3,
color: '#2a7ee4',
}, {
text: 'Sandra Johnson',
id: 4,
color: '#7b49d3',
},
];
const rooms: Room[] = [
{
text: 'Room 1',
id: 1,
color: '#00af2c',
}, {
text: 'Room 2',
id: 2,
color: '#56ca85',
}, {
text: 'Room 3',
id: 3,
color: '#8ecd3c',
},
];
const priorities: Priority[] = [
{
text: 'High',
id: 1,
color: '#cc5c53',
}, {
text: 'Low',
id: 2,
color: '#ff9747',
},
];
@Injectable()
export class Service {
getAppointments(): Appointment[] {
return appointments;
}
getAssignees(): Assignee[] {
return assignees;
}
getRooms(): Room[] {
return rooms;
}
getPriorities(): Priority[] {
return priorities;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React, { useCallback, useState } from 'react';
import Scheduler, {
Resource,
Editing,
Form as SchedulerForm,
Item,
type SchedulerTypes,
} from 'devextreme-react/scheduler';
import RadioGroup from 'devextreme-react/radio-group';
import type { RadioGroupTypes } from 'devextreme-react/radio-group';
import {
data, assignees, rooms, priorities, resourcesList,
} from './data.ts';
const currentDate = new Date(2021, 3, 27);
const views: SchedulerTypes.ViewType[] = ['workWeek'];
const App = () => {
const [currentResource, setCurrentResource] = useState(resourcesList[0]);
const onRadioGroupValueChanged = useCallback((e: RadioGroupTypes.ValueChangedEvent) => {
setCurrentResource(e.value);
}, []);
return (
<>
<Scheduler
timeZone="America/Los_Angeles"
dataSource={data}
views={views}
defaultCurrentView="workWeek"
defaultCurrentDate={currentDate}
startDayHour={9}
endDayHour={19}
height={600}
>
<Resource
dataSource={rooms}
fieldExpr="roomId"
label="Room"
useColorAsDefault={currentResource === 'Room'}
icon="conferenceroomoutline"
/>
<Resource
dataSource={priorities}
fieldExpr="priorityId"
label="Priority"
useColorAsDefault={currentResource === 'Priority'}
icon="tags"
/>
<Resource
dataSource={assignees}
allowMultiple={true}
fieldExpr="assigneeId"
label="Assignee"
useColorAsDefault={currentResource === 'Assignee'}
icon="user"
/>
<Editing>
<SchedulerForm>
<Item name="mainGroup">
<Item name="subjectGroup" />
<Item name="dateGroup" />
<Item name="repeatGroup" />
<Item name="resourcesGroup">
<Item name="roomIdGroup" colCount={3} colCountByScreen={{ xs: 3 }}>
<Item name="roomIdIcon" />
<Item name="roomIdEditor" />
<Item name="priorityIdEditor" />
</Item>
<Item name="assigneeIdGroup" />
</Item>
<Item name="descriptionGroup" />
</Item>
<Item name="recurrenceGroup" />
</SchedulerForm>
</Editing>
</Scheduler>
<div className="options">
<div className="caption">Use colors of:</div>
<div className="option">
<RadioGroup
items={resourcesList}
value={currentResource}
layout="horizontal"
onValueChanged={onRadioGroupValueChanged}
/>
</div>
</div>
</>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import Scheduler, {
Resource,
Editing,
Form as SchedulerForm,
Item,
} from 'devextreme-react/scheduler';
import RadioGroup from 'devextreme-react/radio-group';
import {
data, assignees, rooms, priorities, resourcesList,
} from './data.js';
const currentDate = new Date(2021, 3, 27);
const views = ['workWeek'];
const App = () => {
const [currentResource, setCurrentResource] = useState(resourcesList[0]);
const onRadioGroupValueChanged = useCallback((e) => {
setCurrentResource(e.value);
}, []);
return (
<>
<Scheduler
timeZone="America/Los_Angeles"
dataSource={data}
views={views}
defaultCurrentView="workWeek"
defaultCurrentDate={currentDate}
startDayHour={9}
endDayHour={19}
height={600}
>
<Resource
dataSource={rooms}
fieldExpr="roomId"
label="Room"
useColorAsDefault={currentResource === 'Room'}
icon="conferenceroomoutline"
/>
<Resource
dataSource={priorities}
fieldExpr="priorityId"
label="Priority"
useColorAsDefault={currentResource === 'Priority'}
icon="tags"
/>
<Resource
dataSource={assignees}
allowMultiple={true}
fieldExpr="assigneeId"
label="Assignee"
useColorAsDefault={currentResource === 'Assignee'}
icon="user"
/>
<Editing>
<SchedulerForm>
<Item name="mainGroup">
<Item name="subjectGroup" />
<Item name="dateGroup" />
<Item name="repeatGroup" />
<Item name="resourcesGroup">
<Item
name="roomIdGroup"
colCount={3}
colCountByScreen={{ xs: 3 }}
>
<Item name="roomIdIcon" />
<Item name="roomIdEditor" />
<Item name="priorityIdEditor" />
</Item>
<Item name="assigneeIdGroup" />
</Item>
<Item name="descriptionGroup" />
</Item>
<Item name="recurrenceGroup" />
</SchedulerForm>
</Editing>
</Scheduler>
<div className="options">
<div className="caption">Use colors of:</div>
<div className="option">
<RadioGroup
items={resourcesList}
value={currentResource}
layout="horizontal"
onValueChanged={onRadioGroupValueChanged}
/>
</div>
</div>
</>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { SchedulerTypes } from 'devextreme-react/scheduler';
type Appointment = SchedulerTypes.Appointment & { priorityId: number, roomId: number, assigneeId: number[] };
export const resourcesList = ['Assignee', 'Room', 'Priority'];
export const data: Appointment[] = [
{
text: 'Website Re-Design Plan',
assigneeId: [4],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-26T16:30:00.000Z'),
endDate: new Date('2021-04-26T18:30:00.000Z'),
}, {
text: 'Book Flights to San Fran for Sales Trip',
assigneeId: [2],
roomId: 2,
priorityId: 1,
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
allDay: true,
}, {
text: 'Install New Router in Dev Room',
assigneeId: [1],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-26T21:30:00.000Z'),
endDate: new Date('2021-04-26T22:30:00.000Z'),
}, {
text: 'Approve Personal Computer Upgrade Plan',
assigneeId: [3],
roomId: 2,
priorityId: 2,
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
assigneeId: [1],
roomId: 1,
priorityId: 1,
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
}, {
text: 'New Brochures',
assigneeId: [4],
roomId: 3,
priorityId: 2,
startDate: new Date('2021-04-27T21:30:00.000Z'),
endDate: new Date('2021-04-27T22:45:00.000Z'),
}, {
text: 'Install New Database',
assigneeId: [2],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-28T16:45:00.000Z'),
endDate: new Date('2021-04-28T18:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
assigneeId: [4],
roomId: 2,
priorityId: 1,
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
assigneeId: [2],
roomId: 2,
priorityId: 2,
startDate: new Date('2021-04-28T22:15:00.000Z'),
endDate: new Date('2021-04-28T23:30:00.000Z'),
}, {
text: 'Customer Workshop',
assigneeId: [3],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T19:00:00.000Z'),
allDay: true,
}, {
text: 'Prepare 2021 Marketing Plan',
assigneeId: [1],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
}, {
text: 'Brochure Design Review',
assigneeId: [4],
roomId: 1,
priorityId: 1,
startDate: new Date('2021-04-29T21:00:00.000Z'),
endDate: new Date('2021-04-29T22:30:00.000Z'),
}, {
text: 'Create Icons for Website',
assigneeId: [3],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-30T17:00:00.000Z'),
endDate: new Date('2021-04-30T18:30:00.000Z'),
}, {
text: 'Upgrade Server Hardware',
assigneeId: [4],
roomId: 2,
priorityId: 2,
startDate: new Date('2021-04-30T21:30:00.000Z'),
endDate: new Date('2021-04-30T23:00:00.000Z'),
}, {
text: 'Submit New Website Design',
assigneeId: [1],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-30T23:30:00.000Z'),
endDate: new Date('2021-05-01T01:00:00.000Z'),
}, {
text: 'Launch New Website',
assigneeId: [2],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-30T19:20:00.000Z'),
endDate: new Date('2021-04-30T21:00:00.000Z'),
},
];
export const assignees = [
{
text: 'Samantha Bright',
id: 1,
color: '#727bd2',
}, {
text: 'John Heart',
id: 2,
color: '#32c9ed',
}, {
text: 'Todd Hoffman',
id: 3,
color: '#2a7ee4',
}, {
text: 'Sandra Johnson',
id: 4,
color: '#7b49d3',
},
];
export const rooms = [
{
text: 'Room 1',
id: 1,
color: '#00af2c',
}, {
text: 'Room 2',
id: 2,
color: '#56ca85',
}, {
text: 'Room 3',
id: 3,
color: '#8ecd3c',
},
];
export const priorities = [
{
text: 'High',
id: 1,
color: '#cc5c53',
}, {
text: 'Low',
id: 2,
color: '#ff9747',
},
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const resourcesList = ['Assignee', 'Room', 'Priority'];
export const data = [
{
text: 'Website Re-Design Plan',
assigneeId: [4],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-26T16:30:00.000Z'),
endDate: new Date('2021-04-26T18:30:00.000Z'),
},
{
text: 'Book Flights to San Fran for Sales Trip',
assigneeId: [2],
roomId: 2,
priorityId: 1,
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
allDay: true,
},
{
text: 'Install New Router in Dev Room',
assigneeId: [1],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-26T21:30:00.000Z'),
endDate: new Date('2021-04-26T22:30:00.000Z'),
},
{
text: 'Approve Personal Computer Upgrade Plan',
assigneeId: [3],
roomId: 2,
priorityId: 2,
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
},
{
text: 'Final Budget Review',
assigneeId: [1],
roomId: 1,
priorityId: 1,
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
},
{
text: 'New Brochures',
assigneeId: [4],
roomId: 3,
priorityId: 2,
startDate: new Date('2021-04-27T21:30:00.000Z'),
endDate: new Date('2021-04-27T22:45:00.000Z'),
},
{
text: 'Install New Database',
assigneeId: [2],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-28T16:45:00.000Z'),
endDate: new Date('2021-04-28T18:15:00.000Z'),
},
{
text: 'Approve New Online Marketing Strategy',
assigneeId: [4],
roomId: 2,
priorityId: 1,
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
},
{
text: 'Upgrade Personal Computers',
assigneeId: [2],
roomId: 2,
priorityId: 2,
startDate: new Date('2021-04-28T22:15:00.000Z'),
endDate: new Date('2021-04-28T23:30:00.000Z'),
},
{
text: 'Customer Workshop',
assigneeId: [3],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T19:00:00.000Z'),
allDay: true,
},
{
text: 'Prepare 2021 Marketing Plan',
assigneeId: [1],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
},
{
text: 'Brochure Design Review',
assigneeId: [4],
roomId: 1,
priorityId: 1,
startDate: new Date('2021-04-29T21:00:00.000Z'),
endDate: new Date('2021-04-29T22:30:00.000Z'),
},
{
text: 'Create Icons for Website',
assigneeId: [3],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-30T17:00:00.000Z'),
endDate: new Date('2021-04-30T18:30:00.000Z'),
},
{
text: 'Upgrade Server Hardware',
assigneeId: [4],
roomId: 2,
priorityId: 2,
startDate: new Date('2021-04-30T21:30:00.000Z'),
endDate: new Date('2021-04-30T23:00:00.000Z'),
},
{
text: 'Submit New Website Design',
assigneeId: [1],
roomId: 1,
priorityId: 2,
startDate: new Date('2021-04-30T23:30:00.000Z'),
endDate: new Date('2021-05-01T01:00:00.000Z'),
},
{
text: 'Launch New Website',
assigneeId: [2],
roomId: 3,
priorityId: 1,
startDate: new Date('2021-04-30T19:20:00.000Z'),
endDate: new Date('2021-04-30T21:00:00.000Z'),
},
];
export const assignees = [
{
text: 'Samantha Bright',
id: 1,
color: '#727bd2',
},
{
text: 'John Heart',
id: 2,
color: '#32c9ed',
},
{
text: 'Todd Hoffman',
id: 3,
color: '#2a7ee4',
},
{
text: 'Sandra Johnson',
id: 4,
color: '#7b49d3',
},
];
export const rooms = [
{
text: 'Room 1',
id: 1,
color: '#00af2c',
},
{
text: 'Room 2',
id: 2,
color: '#56ca85',
},
{
text: 'Room 3',
id: 3,
color: '#8ecd3c',
},
];
export const priorities = [
{
text: 'High',
id: 1,
color: '#cc5c53',
},
{
text: 'Low',
id: 2,
color: '#ff9747',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: inline-block;
}

DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Scheduler - Resources

Users can categorize appointments by resources. The following example illustrates what resources are: in an educational center lectures are held in several rooms. In Scheduler terms, room is a resource kind, individual rooms are resource instances, and lectures are appointments that use these resource instances.

Backend API
<template> <div> <DxScheduler time-zone="America/Los_Angeles" :data-source="dataSource" :current-date="currentDate" :views="views" :height="600" :start-day-hour="9" :first-day-of-week="1" current-view="workWeek" > <DxResource :data-source="rooms" :use-color-as-default="currentResource === 'Room'" field-expr="roomId" label="Room" icon="conferenceroomoutline" /> <DxResource :data-source="priorities" :use-color-as-default="currentResource === 'Priority'" field-expr="priorityId" label="Priority" icon="tags" /> <DxResource :data-source="assignees" :use-color-as-default="currentResource === 'Assignee'" field-expr="assigneeId" label="Assignee" :allow-multiple="true" icon="user" /> <DxEditing> <DxSchedulerForm> <DxItem name="mainGroup"> <DxItem name="subjectGroup"/> <DxItem name="dateGroup"/> <DxItem name="repeatGroup"/> <DxItem name="resourcesGroup"> <DxItem :col-count="3" :col-count-by-screen="{ xs: 3 }" name="roomIdGroup" > <DxItem name="roomIdIcon"/> <DxItem name="roomIdEditor"/> <DxItem name="priorityIdEditor"/> </DxItem> <DxItem name="assigneeIdGroup"/> </DxItem> <DxItem name="descriptionGroup"/> </DxItem> <DxItem name="recurrenceGroup"/> </DxSchedulerForm> </DxEditing> </DxScheduler> <div class="options"> <div class="caption">Use colors of:</div> <div class="option"> <DxRadioGroup :items="resources" :value="currentResource" :on-value-changed="onRadioGroupValueChanged" layout="horizontal" /> </div> </div> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import DxScheduler, { DxResource, DxEditing, DxForm as DxSchedulerForm, type DxSchedulerTypes, } from 'devextreme-vue/scheduler'; import { DxItem } from 'devextreme-vue/form'; import DxRadioGroup, { type DxRadioGroupTypes } from 'devextreme-vue/radio-group'; import { resourcesList, data, priorities, assignees, rooms, } from './data.ts'; const views: DxSchedulerTypes.ViewType[] = ['workWeek']; const currentDate = new Date(2021, 3, 27); const currentResource = ref('Assignee'); const dataSource = data; const resources = resourcesList; function onRadioGroupValueChanged(e: DxRadioGroupTypes.ValueChangedEvent) { currentResource.value = e.value; } </script> <style scoped> .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); margin-top: 20px; } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; display: inline-block; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
export const resourcesList = ['Assignee', 'Room', 'Priority']; export const data = [ { text: 'Website Re-Design Plan', assigneeId: [4], roomId: 1, priorityId: 2, startDate: new Date('2021-04-26T16:30:00.000Z'), endDate: new Date('2021-04-26T18:30:00.000Z'), }, { text: 'Book Flights to San Fran for Sales Trip', assigneeId: [2], roomId: 2, priorityId: 1, startDate: new Date('2021-04-26T19:00:00.000Z'), endDate: new Date('2021-04-26T20:00:00.000Z'), allDay: true, }, { text: 'Install New Router in Dev Room', assigneeId: [1], roomId: 1, priorityId: 2, startDate: new Date('2021-04-26T21:30:00.000Z'), endDate: new Date('2021-04-26T22:30:00.000Z'), }, { text: 'Approve Personal Computer Upgrade Plan', assigneeId: [3], roomId: 2, priorityId: 2, startDate: new Date('2021-04-27T17:00:00.000Z'), endDate: new Date('2021-04-27T18:00:00.000Z'), }, { text: 'Final Budget Review', assigneeId: [1], roomId: 1, priorityId: 1, startDate: new Date('2021-04-27T19:00:00.000Z'), endDate: new Date('2021-04-27T20:35:00.000Z'), }, { text: 'New Brochures', assigneeId: [4], roomId: 3, priorityId: 2, startDate: new Date('2021-04-27T21:30:00.000Z'), endDate: new Date('2021-04-27T22:45:00.000Z'), }, { text: 'Install New Database', assigneeId: [2], roomId: 3, priorityId: 1, startDate: new Date('2021-04-28T16:45:00.000Z'), endDate: new Date('2021-04-28T18:15:00.000Z'), }, { text: 'Approve New Online Marketing Strategy', assigneeId: [4], roomId: 2, priorityId: 1, startDate: new Date('2021-04-28T19:00:00.000Z'), endDate: new Date('2021-04-28T21:00:00.000Z'), }, { text: 'Upgrade Personal Computers', assigneeId: [2], roomId: 2, priorityId: 2, startDate: new Date('2021-04-28T22:15:00.000Z'), endDate: new Date('2021-04-28T23:30:00.000Z'), }, { text: 'Customer Workshop', assigneeId: [3], roomId: 3, priorityId: 1, startDate: new Date('2021-04-29T18:00:00.000Z'), endDate: new Date('2021-04-29T19:00:00.000Z'), allDay: true, }, { text: 'Prepare 2021 Marketing Plan', assigneeId: [1], roomId: 1, priorityId: 2, startDate: new Date('2021-04-29T18:00:00.000Z'), endDate: new Date('2021-04-29T20:30:00.000Z'), }, { text: 'Brochure Design Review', assigneeId: [4], roomId: 1, priorityId: 1, startDate: new Date('2021-04-29T21:00:00.000Z'), endDate: new Date('2021-04-29T22:30:00.000Z'), }, { text: 'Create Icons for Website', assigneeId: [3], roomId: 3, priorityId: 1, startDate: new Date('2021-04-30T17:00:00.000Z'), endDate: new Date('2021-04-30T18:30:00.000Z'), }, { text: 'Upgrade Server Hardware', assigneeId: [4], roomId: 2, priorityId: 2, startDate: new Date('2021-04-30T21:30:00.000Z'), endDate: new Date('2021-04-30T23:00:00.000Z'), }, { text: 'Submit New Website Design', assigneeId: [1], roomId: 1, priorityId: 2, startDate: new Date('2021-04-30T23:30:00.000Z'), endDate: new Date('2021-05-01T01:00:00.000Z'), }, { text: 'Launch New Website', assigneeId: [2], roomId: 3, priorityId: 1, startDate: new Date('2021-04-30T19:20:00.000Z'), endDate: new Date('2021-04-30T21:00:00.000Z'), }, ]; export const assignees = [ { text: 'Samantha Bright', id: 1, color: '#727bd2', }, { text: 'John Heart', id: 2, color: '#32c9ed', }, { text: 'Todd Hoffman', id: 3, color: '#2a7ee4', }, { text: 'Sandra Johnson', id: 4, color: '#7b49d3', }, ]; export const rooms = [ { text: 'Room 1', id: 1, color: '#00af2c', }, { text: 'Room 2', id: 2, color: '#56ca85', }, { text: 'Room 3', id: 3, color: '#8ecd3c', }, ]; export const priorities = [ { text: 'High', id: 1, color: '#cc5c53', }, { text: 'Low', id: 2, color: '#ff9747', }, ];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

Define Resource Kinds

Use the resources array to define resource kinds. Each object in this array should contain at least the following fields:

  • dataSource
    Resource instances of this resource kind. Each instance should contain the id, text, and color fields. If your field names differ, specify them in the valueExpr, displayExpr, and colorExpr properties, respectively.

  • fieldExpr
    A data field used to assign instances of this resource kind to appointments. Add this field to appointment objects and set the field values to id values of resource instances.

In this demo, the resources array contains three resource kinds: rooms, priorities, and assignees. Their fieldExpr values are roomId, priorityId, and assigneeId, respectively. Each appointment contains the same fields. Field values assign the appointments to different instances of these resource kinds.

Color Appointments Based on a Resource Kind

To use the color scheme of a specific resource kind, enable the kind's useColorAsDefault property. Otherwise, appointments use the color scheme of the last resource kind declared in the resources array.

This demo enables you to change the useColorAsDefault property at runtime. Click the radio buttons under the Scheduler to switch between different color schemes.

Assign Multiple Instances of a Resource Kind

Each resource kind object can contain the allowMultiple property. When this property is set to true, users can assign multiple instances of this kind to a single appointment. In this demo, the Assignee resource kind allows multiple instances.

You can also group appointments by resources as shown in the following demo: Group Orientation.